﻿using System;
using System.Windows;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 회전 매트릭스 - RotateMatrix

        /// <summary>
        /// 회전 매트릭스
        /// </summary>
        public Matrix RotateMatrix { get; set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            DataContext = this;

            RotateMatrix = GetRotateMatrix(30);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 회전 매트릭스 구하기 - GetRotateMatrix(angle)

        /// <summary>
        /// 회전 매트릭스 구하기
        /// </summary>
        /// <param name="angle">각도</param>
        /// <returns>회전 매트릭스</returns>
        private Matrix GetRotateMatrix(double angle)
        {
            double radian      = angle * (Math.PI / 180d);
            double cosineValue = Math.Cos(radian);
            double sineValue   = Math.Sin(radian);

            Matrix matrix = new Matrix();

            matrix.M11     = cosineValue;
            matrix.M12     = sineValue;
            matrix.M21     = -sineValue;
            matrix.M22     = cosineValue;
            matrix.OffsetX = 0;
            matrix.OffsetY = 0;

            return matrix;
        }

        #endregion
    }
}